diff --git a/app/Http/Controllers/Api/Profile/DetailsController.php b/app/Http/Controllers/Api/Profile/DetailsController.php
new file mode 100644
index 0000000..1940bef
--- /dev/null
+++ b/app/Http/Controllers/Api/Profile/DetailsController.php
@@ -0,0 +1,61 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Profile;
+
+use Portal\Events\User\UpdatedProfileDetails;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\User\UpdateProfileDetailsRequest;
+use Portal\Repositories\User\UserRepository;
+use Portal\Transformers\UserTransformer;
+
+/**
+ * Class DetailsController
+ * @package Portal\Http\Controllers\Api\Profile
+ */
+class DetailsController extends ApiController
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+    }
+
+    /**
+     * Handle user details request.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index()
+    {
+        return $this->respondWithItem(
+            auth()->user(),
+            new UserTransformer
+        );
+    }
+
+    /**
+     * Updates user profile details.
+     * @param UpdateProfileDetailsRequest $request
+     * @param UserRepository $users
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function update(UpdateProfileDetailsRequest $request, UserRepository $users)
+    {
+        $user = $request->user();
+
+        $data = collect($request->all());
+
+        $data = $data->only([
+            'first_name', 'last_name', 'birthday',
+            'phone', 'address', 'country_id'
+        ])->toArray();
+
+        if (! isset($data['country_id'])) {
+            $data['country_id'] = $user->country_id;
+        }
+
+        $user = $users->update($user->id, $data);
+
+        event(new UpdatedProfileDetails);
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+}
diff --git a/app/Http/Controllers/Api/Profile/SessionsController.php b/app/Http/Controllers/Api/Profile/SessionsController.php
new file mode 100644
index 0000000..a8fb269
--- /dev/null
+++ b/app/Http/Controllers/Api/Profile/SessionsController.php
@@ -0,0 +1,35 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Profile;
+
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Repositories\Session\SessionRepository;
+use Portal\Transformers\SessionTransformer;
+
+/**
+ * Class DetailsController
+ * @package Portal\Http\Controllers\Api\Profile
+ */
+class SessionsController extends ApiController
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+        $this->middleware('session.database');
+    }
+
+    /**
+     * Handle user details request.
+     * @param SessionRepository $sessions
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index(SessionRepository $sessions)
+    {
+        $sessions = $sessions->getUserSessions(auth()->id());
+
+        return $this->respondWithCollection(
+            $sessions,
+            new SessionTransformer
+        );
+    }
+}
diff --git a/app/Http/Controllers/Api/Profile/TwoFactorController.php b/app/Http/Controllers/Api/Profile/TwoFactorController.php
new file mode 100644
index 0000000..b272a1a
--- /dev/null
+++ b/app/Http/Controllers/Api/Profile/TwoFactorController.php
@@ -0,0 +1,72 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Profile;
+
+use Authy;
+use Portal\Events\User\TwoFactorDisabled;
+use Portal\Events\User\TwoFactorEnabled;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\User\EnableTwoFactorRequest;
+use Portal\Transformers\UserTransformer;
+
+/**
+ * Class TwoFactorController
+ * @package Portal\Http\Controllers\Api\Profile
+ */
+class TwoFactorController extends ApiController
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+    }
+
+    /**
+     * Enable 2FA for specified user.
+     * @param EnableTwoFactorRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function update(EnableTwoFactorRequest $request)
+    {
+        $user = auth()->user();
+
+        if (Authy::isEnabled($user)) {
+            return $this->setStatusCode(422)
+                ->respondWithError("2FA is already enabled for this user.");
+        }
+
+        $user->setAuthPhoneInformation(
+            $request->country_code,
+            $request->phone_number
+        );
+
+        Authy::register($user);
+
+        $user->save();
+
+        event(new TwoFactorEnabled);
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+
+    /**
+     * Disable 2FA for currently authenticated user.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function destroy()
+    {
+        $user = auth()->user();
+
+        if (! Authy::isEnabled($user)) {
+            return $this->setStatusCode(422)
+                ->respondWithError("2FA is not enabled for this user.");
+        }
+
+        Authy::delete($user);
+
+        $user->save();
+
+        event(new TwoFactorDisabled);
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+}
diff --git a/app/Http/Controllers/Api/SessionsController.php b/app/Http/Controllers/Api/SessionsController.php
new file mode 100644
index 0000000..7ea8a43
--- /dev/null
+++ b/app/Http/Controllers/Api/SessionsController.php
@@ -0,0 +1,54 @@
+<?php
+
+namespace Portal\Http\Controllers\Api;
+
+use Portal\Repositories\Session\SessionRepository;
+use Portal\Transformers\SessionTransformer;
+
+/**
+ * Class SessionsController
+ * @package Portal\Http\Controllers\Api\Users
+ */
+class SessionsController extends ApiController
+{
+    /**
+     * @var SessionRepository
+     */
+    private $sessions;
+
+    public function __construct(SessionRepository $sessions)
+    {
+        $this->middleware('auth');
+        $this->middleware('session.database');
+        $this->sessions = $sessions;
+    }
+
+    /**
+     * Get info about specified session.
+     * @param $session
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function show($session)
+    {
+        $this->authorize('manage-session', $session);
+
+        return $this->respondWithItem(
+            $session,
+            new SessionTransformer
+        );
+    }
+
+    /**
+     * Destroy specified session.
+     * @param $session
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function destroy($session)
+    {
+        $this->authorize('manage-session', $session);
+
+        $this->sessions->invalidateSession($session->id);
+
+        return $this->respondWithSuccess();
+    }
+}
diff --git a/app/Http/Controllers/Api/SettingsController.php b/app/Http/Controllers/Api/SettingsController.php
new file mode 100644
index 0000000..f2d536b
--- /dev/null
+++ b/app/Http/Controllers/Api/SettingsController.php
@@ -0,0 +1,26 @@
+<?php
+
+namespace Portal\Http\Controllers\Api;
+
+use Settings;
+
+/**
+ * Class SettingsController
+ * @package Portal\Http\Controllers\Api\Settings
+ */
+class SettingsController extends ApiController
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+        $this->middleware('permission:settings.general');
+    }
+    /**
+     * System settings.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index()
+    {
+        return Settings::all();
+    }
+}
diff --git a/app/Http/Controllers/Api/StatsController.php b/app/Http/Controllers/Api/StatsController.php
new file mode 100644
index 0000000..289c7c6
--- /dev/null
+++ b/app/Http/Controllers/Api/StatsController.php
@@ -0,0 +1,92 @@
+<?php
+
+namespace Portal\Http\Controllers\Api;
+
+use Auth;
+use Carbon\Carbon;
+use League\Fractal\Resource\Collection;
+use Portal\Repositories\Activity\ActivityRepository;
+use Portal\Repositories\User\UserRepository;
+use Portal\Support\Enum\UserStatus;
+use Portal\Transformers\UserTransformer;
+
+/**
+ * Class StatsController
+ * @package Portal\Http\Controllers\Api
+ */
+class StatsController extends ApiController
+{
+    /**
+     * @var UserRepository
+     */
+    private $users;
+    /**
+     * @var ActivityRepository
+     */
+    private $activities;
+
+    public function __construct(UserRepository $users, ActivityRepository $activities)
+    {
+        $this->middleware('auth');
+        $this->users = $users;
+        $this->activities = $activities;
+    }
+
+    /**
+     * @return \Illuminate\Http\JsonResponse|mixed
+     */
+    public function index()
+    {
+        if (Auth::user()->hasRole('Admin')) {
+            return $this->adminStats();
+        }
+
+        return $this->defaultStats();
+    }
+
+    /**
+     * Get admin stats with details about users per
+     * status and users per month for current year.
+     * @return \Illuminate\Http\JsonResponse
+     */
+    private function adminStats()
+    {
+        $usersPerMonth = $this->users->countOfNewUsersPerMonth(
+            Carbon::now()->startOfYear(),
+            Carbon::now()
+        );
+
+        $usersPerStatus = [
+            'total' => $this->users->count(),
+            'new' => $this->users->newUsersCount(),
+            'banned' => $this->users->countByStatus(UserStatus::BANNED),
+            'unconfirmed' => $this->users->countByStatus(UserStatus::UNCONFIRMED)
+        ];
+
+        $latestRegistrations = $this->users->latest(7);
+
+        $resource = new Collection(
+            $latestRegistrations,
+            new UserTransformer
+        );
+
+        return $this->respondWithArray([
+            'users_per_month' => $usersPerMonth,
+            'users_per_status' => $usersPerStatus,
+            'latest_registrations' => $this->fractal()->createData($resource)->toArray()
+        ]);
+    }
+
+    /**
+     * Get user activity for each day in specified period.
+     * @return mixed
+     */
+    private function defaultStats()
+    {
+        return $this->activities->userActivityForPeriod(
+            Auth::user()->id,
+            Carbon::now()->subWeeks(2),
+            Carbon::now()
+        );
+    }
+}
diff --git a/app/Http/Controllers/Api/Users/ActivityController.php b/app/Http/Controllers/Api/Users/ActivityController.php
new file mode 100644
index 0000000..3a1d0e5
--- /dev/null
+++ b/app/Http/Controllers/Api/Users/ActivityController.php
@@ -0,0 +1,49 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Users;
+
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\Activity\GetActivitiesRequest;
+use Portal\Repositories\Activity\ActivityRepository;
+use Portal\Transformers\ActivityTransformer;
+use Portal\User;
+
+/**
+ * Class ActivityController
+ * @package Portal\Http\Controllers\Api\Users
+ */
+class ActivityController extends ApiController
+{
+    /**
+     * @var ActivityRepository
+     */
+    private $activities;
+
+    public function __construct(ActivityRepository $activities)
+    {
+        $this->middleware('auth');
+        $this->middleware('permission:users.activity');
+
+        $this->activities = $activities;
+    }
+
+    /**
+     * Get activities for specified user.
+     * @param User $user
+     * @param GetActivitiesRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index(User $user, GetActivitiesRequest $request)
+    {
+        $activities = $this->activities->paginateActivitiesForUser(
+            $user->id,
+            $request->per_page ?: 20,
+            $request->search
+        );
+
+        return $this->respondWithPagination(
+            $activities,
+            new ActivityTransformer
+        );
+    }
+}
diff --git a/app/Http/Controllers/Api/Users/AvatarController.php b/app/Http/Controllers/Api/Users/AvatarController.php
new file mode 100644
index 0000000..4b9a849
--- /dev/null
+++ b/app/Http/Controllers/Api/Users/AvatarController.php
@@ -0,0 +1,106 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Users;
+
+use Illuminate\Http\Request;
+use Portal\Events\User\UpdatedByAdmin;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\User\CreateUserRequest;
+use Portal\Http\Requests\User\UpdateUserRequest;
+use Portal\Http\Requests\User\UploadAvatarRawRequest;
+use Portal\Repositories\User\UserRepository;
+use Portal\Services\Upload\UserAvatarManager;
+use Portal\Support\Enum\UserStatus;
+use Portal\Transformers\UserTransformer;
+use Portal\User;
+
+/**
+ * Class AvatarController
+ * @package Portal\Http\Controllers\Api\Users
+ */
+class AvatarController extends ApiController
+{
+    /**
+     * @var UserRepository
+     */
+    private $users;
+
+    /**
+     * @var UserAvatarManager
+     */
+    private $avatarManager;
+
+    public function __construct(UserRepository $users, UserAvatarManager $avatarManager)
+    {
+        $this->middleware('auth');
+        $this->middleware('permission:users.manage');
+
+        $this->users = $users;
+        $this->avatarManager = $avatarManager;
+    }
+
+    /**
+     * @param User $user
+     * @param UploadAvatarRawRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function update(User $user, UploadAvatarRawRequest $request)
+    {
+        $name = $this->avatarManager->uploadAndCropAvatar(
+            $user,
+            $request->file('file')
+        );
+
+        $user = $this->users->update(
+            $user->id,
+            ['avatar' => $name]
+        );
+
+        event(new UpdatedByAdmin($user));
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+
+    /**
+     * Update user's avatar to external resource.
+     * @param User $user
+     * @param Request $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function updateExternal(User $user, Request $request)
+    {
+        $this->validate($request, [
+            'url' => 'required|url'
+        ]);
+
+        $this->avatarManager->deleteAvatarIfUploaded($user);
+
+        $user = $this->users->update(
+            $user->id,
+            ['avatar' => $request->url]
+        );
+
+        event(new UpdatedByAdmin($user));
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+
+    /**
+     * Remove user's avatar and set it to null.
+     * @param User $user
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function destroy(User $user)
+    {
+        $this->avatarManager->deleteAvatarIfUploaded($user);
+
+        $user = $this->users->update(
+            $user->id,
+            ['avatar' => null]
+        );
+
+        event(new UpdatedByAdmin($user));
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+}
diff --git a/app/Http/Controllers/Api/Users/SessionsController.php b/app/Http/Controllers/Api/Users/SessionsController.php
new file mode 100644
index 0000000..eeb2077
--- /dev/null
+++ b/app/Http/Controllers/Api/Users/SessionsController.php
@@ -0,0 +1,36 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Users;
+
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Repositories\Session\SessionRepository;
+use Portal\Transformers\SessionTransformer;
+use Portal\User;
+
+/**
+ * Class SessionsController
+ * @package Portal\Http\Controllers\Api\Users
+ */
+class SessionsController extends ApiController
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+        $this->middleware('permission:users.manage');
+        $this->middleware('session.database');
+    }
+
+    /**
+     * Get sessions for specified user.
+     * @param User $user
+     * @param SessionRepository $sessions
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index(User $user, SessionRepository $sessions)
+    {
+        return $this->respondWithCollection(
+            $sessions->getUserSessions($user->id),
+            new SessionTransformer
+        );
+    }
+}
diff --git a/app/Http/Controllers/Api/Users/TwoFactorController.php b/app/Http/Controllers/Api/Users/TwoFactorController.php
new file mode 100644
index 0000000..c066eb1
--- /dev/null
+++ b/app/Http/Controllers/Api/Users/TwoFactorController.php
@@ -0,0 +1,72 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Users;
+
+use Authy;
+use Portal\Events\User\TwoFactorDisabledByAdmin;
+use Portal\Events\User\TwoFactorEnabledByAdmin;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\User\EnableTwoFactorRequest;
+use Portal\Transformers\UserTransformer;
+use Portal\User;
+
+/**
+ * Class TwoFactorController
+ * @package Portal\Http\Controllers\Api\Users
+ */
+class TwoFactorController extends ApiController
+{
+    public function __construct()
+    {
+        $this->middleware('auth');
+        $this->middleware('permission:users.manage');
+    }
+
+    /**
+     * Enable 2FA for specified user.
+     * @param User $user
+     * @param EnableTwoFactorRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function update(User $user, EnableTwoFactorRequest $request)
+    {
+        if (Authy::isEnabled($user)) {
+            return $this->setStatusCode(422)
+                ->respondWithError("2FA is already enabled for this user.");
+        }
+
+        $user->setAuthPhoneInformation(
+            $request->country_code,
+            $request->phone_number
+        );
+
+        Authy::register($user);
+
+        $user->save();
+
+        event(new TwoFactorEnabledByAdmin($user));
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+
+    /**
+     * Disable 2FA for specified user.
+     * @param User $user
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function destroy(User $user)
+    {
+        if (! Authy::isEnabled($user)) {
+            return $this->setStatusCode(422)
+                ->respondWithError("2FA is not enabled for this user.");
+        }
+
+        Authy::delete($user);
+
+        $user->save();
+
+        event(new TwoFactorDisabledByAdmin($user));
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+}
diff --git a/app/Http/Controllers/Api/Users/UsersController.php b/app/Http/Controllers/Api/Users/UsersController.php
new file mode 100644
index 0000000..2147aa4
--- /dev/null
+++ b/app/Http/Controllers/Api/Users/UsersController.php
@@ -0,0 +1,141 @@
+<?php
+
+namespace Portal\Http\Controllers\Api\Users;
+
+use Illuminate\Http\Request;
+use Portal\Events\User\Banned;
+use Portal\Events\User\Deleted;
+use Portal\Events\User\UpdatedByAdmin;
+use Portal\Http\Controllers\Api\ApiController;
+use Portal\Http\Requests\User\CreateUserRequest;
+use Portal\Http\Requests\User\UpdateUserRequest;
+use Portal\Repositories\User\UserRepository;
+use Portal\Support\Enum\UserStatus;
+use Portal\Transformers\UserTransformer;
+use Portal\User;
+
+/**
+ * Class UsersController
+ * @package Portal\Http\Controllers\Api\Users
+ */
+class UsersController extends ApiController
+{
+    /**
+     * @var UserRepository
+     */
+    private $users;
+
+    public function __construct(UserRepository $users)
+    {
+        $this->middleware('auth');
+        $this->middleware('permission:users.manage');
+
+        $this->users = $users;
+    }
+
+    /**
+     * Paginate all users.
+     * @param Request $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function index(Request $request)
+    {
+        $users = $this->users->paginate(
+            $request->per_page ?: 20,
+            $request->search,
+            $request->status
+        );
+
+        return $this->respondWithPagination(
+            $users,
+            new UserTransformer
+        );
+    }
+
+    /**
+     * Create new user record.
+     * @param CreateUserRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function store(CreateUserRequest $request)
+    {
+        $data = $request->only([
+            'email', 'password', 'username', 'first_name', 'last_name',
+            'phone', 'address', 'country_id', 'birthday', 'role_id'
+        ]);
+
+        $data += ['status' => UserStatus::ACTIVE];
+
+        $user = $this->users->create($data);
+
+        return $this->setStatusCode(201)
+            ->respondWithItem($user, new UserTransformer);
+    }
+
+    /**
+     * Show the info about requested user.
+     * @param User $user
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function show(User $user)
+    {
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+
+    /**
+     * @param User $user
+     * @param UpdateUserRequest $request
+     * @return \Illuminate\Http\JsonResponse
+     */
+    public function update(User $user, UpdateUserRequest $request)
+    {
+        $data = collect($request->all());
+
+        $data = $data->only([
+            'email', 'password', 'username', 'first_name', 'last_name',
+            'phone', 'address', 'country_id', 'birthday', 'status', 'role_id'
+        ])->toArray();
+
+        $user = $this->users->update($user->id, $data);
+
+        event(new UpdatedByAdmin($user));
+
+        // If user status was updated to "Banned",
+        // fire the appropriate event.
+        if ($this->userIsBanned($user, $request)) {
+            event(new Banned($user));
+        }
+
+        return $this->respondWithItem($user, new UserTransformer);
+    }
+
+    /**
+     * Check if user is banned during last update.
+     *
+     * @param User $user
+     * @param Request $request
+     * @return bool
+     */
+    private function userIsBanned(User $user, Request $request)
+    {
+        return $user->status != $request->status && $request->status == UserStatus::BANNED;
+    }
+
+    /**
+     * Remove specified user from storage.
+     * @param User $user
+     * @return \Illuminate\Http\Response
+     */
+    public function destroy(User $user)
+    {
+        if ($user->id == auth()->id()) {
+            return $this->errorForbidden("You cannot delete yourself.");
+        }
+
+        event(new Deleted($user));
+
+        $this->users->delete($user->id);
+
+        return $this->respondWithSuccess();
+    }
+}
diff --git a/app/Http/Controllers/ActivityController.php b/app/Http/Controllers/Web/ActivityController.php
similarity index 94%
rename from app/Http/Controllers/ActivityController.php
rename to app/Http/Controllers/Web/ActivityController.php
index 291935b..75c0295 100644
--- a/app/Http/Controllers/ActivityController.php
+++ b/app/Http/Controllers/Web/ActivityController.php
@@ -1,7 +1,8 @@
 <?php
 
-namespace Portal\Http\Controllers;
+namespace Portal\Http\Controllers\Web;
 
+use Portal\Http\Controllers\Controller;
 use Portal\Repositories\Activity\ActivityRepository;
 use Portal\Repositories\Activity\EloquentActivity;
 use Portal\User;
@@ -55,6 +56,7 @@ class ActivityController extends Controller
     public function userActivity(User $user, Request $request)
     {
         $perPage = 20;
+        $perPage = 20;
         $adminView = true;
 
         $activities = $this->activities->paginateActivitiesForUser(
diff --git a/app/Http/Controllers/Auth/AuthController.php b/app/Http/Controllers/Web/Auth/AuthController.php
similarity index 91%
rename from app/Http/Controllers/Auth/AuthController.php
rename to app/Http/Controllers/Web/Auth/AuthController.php
index 84d2288..c1678b2 100644
--- a/app/Http/Controllers/Auth/AuthController.php
+++ b/app/Http/Controllers/Web/Auth/AuthController.php
@@ -1,13 +1,12 @@
 <?php
 
-namespace Portal\Http\Controllers\Auth;
+namespace Portal\Http\Controllers\Web\Auth;
 
 use Portal\Events\User\LoggedIn;
 use Portal\Events\User\LoggedOut;
 use Portal\Events\User\Registered;
 use Portal\Http\Requests\Auth\LoginRequest;
 use Portal\Http\Requests\Auth\RegisterRequest;
-use Portal\Mailers\UserMailer;
 use Portal\Repositories\Role\RoleRepository;
 use Portal\Repositories\User\UserRepository;
 use Portal\Services\Auth\TwoFactor\Contracts\Authenticatable;
@@ -18,7 +17,6 @@ use Carbon\Carbon;
 use Illuminate\Cache\RateLimiter;
 use Illuminate\Http\Request;
 use Portal\Http\Controllers\Controller;
-use Lang;
 use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
 use Validator;
 
@@ -75,7 +73,6 @@ class AuthController extends Controller
         $credentials = $this->getCredentials($request);
 
         if (! Auth::validate($credentials)) {
-
             // If the login attempt was unsuccessful we will increment the number of attempts
             // to login and redirect the user back to the login form. Of course, when this
             // user surpasses their maximum number of attempts they will get locked out.
@@ -159,7 +156,7 @@ class AuthController extends Controller
             $request->session()->pull('auth.2fa.id')
         );
 
-        if ( ! $user) {
+        if (! $user) {
             throw new NotFoundHttpException;
         }
 
@@ -349,10 +346,10 @@ class AuthController extends Controller
      * Handle a registration request for the application.
      *
      * @param RegisterRequest $request
-     * @param UserMailer $mailer
+     * @param RoleRepository $roles
      * @return \Illuminate\Http\Response
      */
-    public function postRegister(RegisterRequest $request, UserMailer $mailer, RoleRepository $roles)
+    public function postRegister(RegisterRequest $request, RoleRepository $roles)
     {
         // Determine user status. User's status will be set to UNCONFIRMED
         // if he has to confirm his email or to ACTIVE if email confirmation is not required
@@ -368,19 +365,12 @@ class AuthController extends Controller
             ['status' => $status, 'role_id' => $role->id]
         ));
 
-        $this->users->updateSocialNetworks($user->id, []);
-
-        // Check if email confirmation is required,
-        // and if it does, send confirmation email to the user.
-        if (settings('reg_email_confirmation')) {
-            $this->sendConfirmationEmail($mailer, $user);
-            $message = trans('app.account_create_confirm_email');
-        } else {
-            $message = trans('app.account_created_login');
-        }
-
         event(new Registered($user));
 
+        $message = settings('reg_email_confirmation')
+            ? trans('app.account_create_confirm_email')
+            : trans('app.account_created_login');
+
         return redirect('login')->with('success', $message);
     }
 
@@ -388,7 +378,7 @@ class AuthController extends Controller
      * Confirm user's email.
      *
      * @param $token
-     * @return $this
+     * @return \Illuminate\Http\RedirectResponse
      */
     public function confirmEmail($token)
     {
@@ -419,15 +409,4 @@ class AuthController extends Controller
             ['username' => 'email']
         )->fails();
     }
-
-    /**
-     * @param UserMailer $mailer
-     * @param $user
-     */
-    private function sendConfirmationEmail(UserMailer $mailer, $user)
-    {
-        $token = str_random(60);
-        $this->users->update($user->id, ['confirmation_token' => $token]);
-        $mailer->sendConfirmationEmail($user, $token);
-    }
 }
diff --git a/app/Http/Controllers/Auth/PasswordController.php b/app/Http/Controllers/Web/Auth/PasswordController.php
similarity index 98%
rename from app/Http/Controllers/Auth/PasswordController.php
rename to app/Http/Controllers/Web/Auth/PasswordController.php
index 53bfbf9..49aae93 100644
--- a/app/Http/Controllers/Auth/PasswordController.php
+++ b/app/Http/Controllers/Web/Auth/PasswordController.php
@@ -1,6 +1,6 @@
 <?php
 
-namespace Portal\Http\Controllers\Auth;
+namespace Portal\Http\Controllers\Web\Auth;
 
 use Illuminate\Http\RedirectResponse;
 use Symfony\Component\HttpKernel\Exception\NotFoundHttpException;
